<?php

$site = "http://fenipulator.brhfl.com/index.php";
$style_file = "http://fenipulator.brhfl.com/style.css";
$pieces_file = "http://fenipulator.brhfl.com/unicode.css";

$rank = array(0 => "8", 1 => "7", 2 => "6", 3 => "5", 4 => "4", 5 => "3", 6 => "2", 7 => "1");
$file = array(0 => "a", 1 => "b", 2 => "c", 3 => "d", 4 => "e", 5 => "f", 6 => "g", 7 => "h");

$rank_inv = array("8" => 0, "7" => 1, "6" => 2, "5" => 3, "4" => 4, "3" => 5, "2" => 6, "1" => 7);
$file_inv = array("a" => 0, "b" => 1, "c" => 2, "d" => 3, "e" => 4, "f" => 5, "g" => 6, "g" => 8);

$from = $_GET['from'];
$to = $_GET['to'];
$fen = $_GET['fen'];
if (empty($fen))
	$fen = "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1";
$fenraw = $fen;
$fen = explode(" ",$fen);
$board = explode("/",$fen[0]);
$turn = &$fen[1];
$castle = &$fen[2];
$en_passant = &$fen[3];
$half_clock = &$fen[4];
$full_clock = &$fen[5];
$flip_state = $_COOKIE["fenipulator-flip"];
if (empty($flip_state))
	$flip_state = "0";
$summary = $_COOKIE["fenipulator-summ"];
if (empty($summary))
	$summary = "0";


/*$flip_state = "1";*/

if (isset($to) && $turn == "w")
	$turn = "b";
elseif (isset($to) && $turn == "b")
	$turn = "w";

if ((isset($_GET['flip'])) && ($flip_state == "0")){
	setcookie("fenipulator-flip","1",time()+31536000);
	$flip_state = "1";
	}
elseif ((isset($_GET['flip'])) && ($flip_state == "1")){
	setcookie("fenipulator-flip","0",time()+31536000);
	$flip_state = "0";
	}

if (isset($_GET['summ'])){
	setcookie("fenipulator-summ","1",time()+31536000);
	$summary = "1";
	}


function space_color($row, $col){
	if ($row%2 == $col%2)
		$color = "dark";
	else
		$color = "light";
	return $color;
	}


function fix_spaces($row) {
	for ($i=0; $i<strlen($row); $i++){
		if ((substr($row,$i,1) != " ") && $count == 0){
			$newrow .= substr($row,$i,1);			
			}
		elseif ((substr($row,$i,1) != " ") && $count > 0){
			$newrow .= $count .= substr($row,$i,1);
			$count = 0;
			}
		else
			$count++;		
		}
		if ($count > 0)
			$newrow .= $count;
		return $newrow;
	}

function fen_to_spaces($row_fen){
	for ($i=0; $i<strlen($row_fen); $i++){
		$current_pos = substr($row_fen,$i,1);
		if (is_numeric($current_pos)){
			for ($j=0; $j<$current_pos; $j++)
				$row .= " ";
			}
		else
			$row .= $current_pos;
		}
	return $row;
	}

function gen_board_from_move ($board, $from, $to){
	global $half_clock, $fen, $castle, $en_passant;
	$from = explode(",",$from);
	$to = explode(",",$to);
	$active = substr(fen_to_spaces($board[$from[0]]),$from[1],1);
	$destination = substr(fen_to_spaces($board[$to[0]]),$to[1],1);
	/*castling*/
	if (($from[0]==0) && ($from[1]==0) && ($active="r"))
		$castle = str_replace("q","",$castle);
	elseif (($from[0]==0) && ($from[1]==7) && ($active="r"))
		$castle = str_replace("k","",$castle);
	elseif (($from[0]==7) && ($from[1]==0) && ($active="R"))
		$castle = str_replace("Q","",$castle);
	elseif (($from[0]==7) && ($from[1]==7) && ($active="R"))
		$castle = str_replace("K","",$castle);
	elseif (($from[0]==0) && ($from[1]==4) && ($active="k")){
		if (($to[0]==0) && ($to[1]==2) && (str_replace("q","",$castle) != $castle)){
			$board = gen_board_from_move($board, "0,0", "0,3");
			}
		elseif (($to[0]==0) && ($to[1]==6) && (str_replace("k","",$castle) != $castle)){
			$board = gen_board_from_move($board, "0,7", "0,5");
			}
		$castle = str_replace("q","",$castle);
		$castle = str_replace("k","",$castle);
		}
	elseif (($from[0]==7) && ($from[1]==4) && ($active="K")){
		if (($to[0]==7) && ($to[1]==2) && (str_replace("Q","",$castle) != $castle)){
			$board = gen_board_from_move($board, "7,0", "7,3");
			}
		elseif (($to[0]==7) && ($to[1]==6) && (str_replace("K","",$castle) != $castle)){
			$board = gen_board_from_move($board, "7,7", "7,5");
			}
		$castle = str_replace("Q","",$castle);
		$castle = str_replace("K","",$castle);
		}
	if ($castle == "")
		$castle = "-";

	/*pawn promotion*/
	if (($to[0] == 7) && ($active="p"))
		$active = "q";
	elseif (($to[0] == 0) && ($active="P"))
		$active = "Q";
	
	$prev_en_passant = $en_passant;
	$en_passant = "-";

	/*en passant*/
	if (($from[0] == 1) && ($to[0]==3) && ($from[1] == $to[1]) && ($active="p")){
		$en_target[0] = 2;
		$en_target[1] = $to[1];
		$en_passant = pos_to_san($en_target);
	}
	elseif (($from[0] == 6) && ($to[0]==4) && ($from[1] == $to[1]) && ($active="P")){
		$en_target[0] = 5;
		$en_target[1] = $to[1];
		$en_passant = pos_to_san($en_target);
	}
	elseif (($prev_en_passant != "-") && ($prev_en_passant == pos_to_san($to)) && (strtolower($active) == "p")){
		if ($active == "p")
			$en_target[0] = 2;
		else
			$en_target[0] = 5;
		$en_target[1] = $to[1];
		/*
		$new_en_row = fen_to_spaces($board[$en_target[0]]);
		$new_en_row[$en_target[1]] = " ";
		$new_en_row = fix_spaces($new_en_row);
		$board[$en_target[0]] = $new_en_row;
		*/
		}

	$new_from_row = fen_to_spaces($board[$from[0]]);
	$new_from_row[$from[1]] = " ";
	if (isset($en_target))
		$new_from_row[$en_target[1]] = " ";
	$new_from_row = fix_spaces($new_from_row);
	$board[$from[0]] = $new_from_row;

	$new_to_row = fen_to_spaces($board[$to[0]]);
	$new_to_row[$to[1]] = $active;
	$new_to_row = fix_spaces($new_to_row);
	

	
	$board[$to[0]] = $new_to_row;

	if ($destination != " ")
		$half_clock = 0;
	elseif (strtolower($active) == "p")
		$half_clock = 0;
	else
		$half_clock++;

	return $board;

	}

function pos_to_san($pos){
	global $rank, $file;
	$san = $file[$pos[1]] . $rank[$pos[0]];
	return $san;
	}

function san_to_pos($san){
	global $rank_inv, $file_inv;
	$pos[0] = $rank_inv[substr($san, 1, 1)];
	$pos[1] = $file_inv[substr($san, 0, 1)];
	return $pos;
	}

if (isset($from) && isset($to))
	$board = gen_board_from_move($board, $from, $to);


function gen_board_from_fen(){
global $board, $from, $to, $fenraw, $turn;
for ($i=0; $i<=7; $i++){
	$pos = 0;
	for ($j=0; $j<strlen($board[$i]); $j++){
		$cur_pos = substr($board[$i],$j,1);
		if (is_numeric($cur_pos)){
			for ($k=0; $k<$cur_pos; $k++){
				$pos++;
				if (isset($from))
					$row .= "<a href='$site?fen=$fenraw&from=$from&to=$i," .($pos-1) . "'><span class='space " . space_color($i,$pos) . "'></span></a>";
				else
					$row .= "<span class='space " . space_color($i,$pos) . "'></span>";		
				}
			}
		else{
			$pos++;
			$from_exp = explode(",",$from);
			if ((isset($_GET['from'])) && ($from_exp[0] == $i) && ($from_exp[1] == ($pos-1)))
				$active = "active";
			else
				$active = "";

			$piece = "<span class='space piece " . $active . " " . $cur_pos . " " . space_color($i,$pos) . "'></span>";
			if (strtoupper($cur_pos) == $cur_pos)
				$cur_color = "w";
			else 
				$cur_color = "b";
			if (empty($from) && $cur_color == $turn)
				$row .= "<a href='$site?fen=$fenraw&from=$i," . ($pos-1) ."'>" . $piece . "</a>";
			elseif (empty($from) && $cur_color != $turn)
				$row .= $piece;
			elseif (isset($from) && $cur_color == $turn)
				$row .= $piece;
			else
				$row .= "<a href='$site?fen=$fenraw&from=$from&to=$i," . ($pos-1) . "'>" . $piece . "</a>";
			}
		}
		$row .= "<br />";
	}

echo $row;
return $row;
}

function gen_fen_from_board($board, $fen, $turn){
	$board = implode("/",$board);
	$fen[0] = $board;
	$fen[1] = $turn;
	return $fen;
	}

function flip_flipper(){
	$flip .= $_SERVER['REQUEST_URI'];
	if (empty($_GET['flip']) && isset($_GET['fen']))
		$flip .= "&flip=true";
	elseif (empty($_GET['flip']) && empty($_GET['fen']))
		$flip .= "?flip=true";
	return $flip;
	}

function summary_flipper(){
	$summflip .= $_SERVER['REQUEST_URI'];
	if (isset($_GET['fen']) || isset($_GET['flip']))
		$summflip .= "&summ=true";
	else
		$summflip .= "?summ=true";
	return $summflip;
	}

function summary_disabler(){
	global $summary;
	if ($summary == "1")
		$output = "<style type='text/css'>#header-summary{display:none;}</style>";
	echo $output;
	}

function flip_handler(){
	global $flip_state;
	if ($flip_state == "1")
		echo "<style type='text/css'> #board{-webkit-transform: rotate(180deg); -moz-transform: rotate(180deg);} .piece{-webkit-transform: rotate(180deg); -moz-transform: rotate(180deg);} </style>";
	}

function gen_status_box(){
	global $fen, $board, $turn, $fenraw, $half_clock, $full_clock, $castle;
	$oldfen = $fenraw;
	$fen = gen_fen_from_board($board, $fen, $turn);
	if ($turn == "w" && isset($_GET['to']))
		$full_clock++;
	$fen[4] = $half_clock;
	$fen[5] = $full_clock;
	$fenraw = implode(" ",$fen);
	/*if (empty($_GET['fen']))*/
	$output .= "Input FEN here and press enter:<br />";
		$output .="<form action='index.php' method='get'><input type='text' name='fen' value='$fenraw' autofocus='autofocus' /><input type='submit' /><br />";
	if ($turn == "w"){
		$output .= "White's turn.<br />";
		if (str_replace("K","",$castle) != $castle)
			$output .= "White can castle kingside.<br />";
		if (str_replace("Q","",$castle) != $castle)
			$output .= "White can castle queenside.<br />";
		}	
	elseif ($turn == "b"){
		$output .= "Black's turn.<br />";
		if (str_replace("k","",$castle) != $castle)
			$output .= "Black can castle kingside.<br />";
		if (str_replace("q","",$castle) != $castle)
			$output .= "Black can castle queenside.<br />";
		}
	$output .= "Halfmoves: " . $half_clock . "<br />";
	$output .= "Fullmoves: " . $full_clock . "<br />";
	$output .= "<a href='$site?fen=$fenraw'>Link to current board state</a> • <a href='$site?fen=$oldfen'>Reset turn</a> • <a href='" . flip_flipper() . "'>Flip board</a><br />"; 
	echo $output;
	}
?>

<?php ob_start(); ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<link rel="stylesheet" href="<?php echo $style_file; ?>" type="text/css" />
<link rel="stylesheet" href="<?php echo $pieces_file; ?>" type="text/css" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

<?php flip_handler(); ?>
<?php summary_disabler(); ?>

<title>fenipulator • <?php echo $fenraw; ?></title>
</head>
<body>

<div id="header">
<span id="fenipulator"><b>fen</b>ipulator</span>
<span id="header-summary">fenipulator, by <a href="http://brhfl.com">brian hefele</a>, is an extremely simple chess board application. i call it a chess <i>board</i> application, and not a <i>chess</i> application, because it has no validation or knowledge of the rules of the game, it does not keep track of games, it does not track check/mate, &amp;c. it really only keeps track of <a href="http://en.wikipedia.org/wiki/Forsyth%E2%80%93Edwards_Notation">fen</a> data. it takes in fen, renders a board, allows the player to make a move, and then generates new fen. <b>basic play is as follows:</b> click to select a piece. click elsewhere to move the piece. to confirm your move, copy the link under 'link to current board state,' and paste that to your opponent. your opponent will then click this link, and do the same. <a href="<?php echo summary_flipper(); ?>">hide summary.</a></span>
<div id="header-menu">
<ul>
	<li><a href="http://te.brhfl.com/2012/01/05/fenipulator/">about</a></li>
	<li><a href="http://fenipulator.brhfl.com/index.php">new board</a></li>
	<li style="display:none"><a href="">options</a></li>
	<li><a href="http://fenipulator.brhfl.com/version-history.txt">version history</a></li>
	<li><a href="http://fenipulator.brhfl.com/fenipulator-0.9.zip">download latest</a></li>
</ul>
</div>
</div>

<div id="board">
<?php gen_board_from_fen();?>
</div>

<div id="status">
<?php gen_status_box();?>
</div>

</body>

</html>


